searchNodes=[{"doc":"Turns the current module into a behaviour based on the specs of publicly defined functions. This is useful in cases where you only have one implementation, but want to use mox to create a mock that you can resolve to in your test environment. Example defmodule Greeter do use Jex.GenerateBehaviour @spec hello :: String . t ( ) def hello ( ) , do : &quot;Hello!&quot; end Mox . defmock ( GreeterMock , for : Greeter )","ref":"Jex.GenerateBehaviour.html","title":"Jex.GenerateBehaviour","type":"module"},{"doc":"Injects dependencies by subjecting aliases to a resolver. The target module of each alias is provided to a resolver that determines which module should actually be aliased in the code follows. By default, that resolver is Jex.Resolver , which simply preserves the initial target. defmodule Example do use Jex.Injector do alias Example.Greeter end def greet ( ) do Greeter . hello ( ) end end A custom resolver can be set in your application config with something like: # config/test.exs import Config config :jex , resolver : MyApp.MockResolver It can also be set using resolve_with/1 , which will change the resolver for all alias statements below. use Jex.Injector do alias Example.Greeter resolve_with MyApp.CustomResolver alias Example.AnotherDependency end Normally the resolver will be called at compile time to determine which module will be injected, however this can be done at runtime using resolve_with/2 with dynamic: true . use Jex.Injector do resolve_with MyApp.FeatureFlagResolver , dynamic : true alias Example.Greeter end","ref":"Jex.Injector.html","title":"Jex.Injector","type":"module"},{"doc":"The resolver behaviour and default implementation. Example defmodule MyApp.MockResolver do use Jex.Resolver @mocks %{ Greeter =&gt; GreeterMock , Cart =&gt; CartMock } for { target , mock } &lt;- @mocks do Mox . defmock ( mock , for : target ) end @impl Jex.Resolver def resolve ( target ) , do : @mocks [ target ] || target end","ref":"Jex.Resolver.html","title":"Jex.Resolver","type":"behaviour"},{"doc":"The default behaviour simply resolves to the original target of the alias.","ref":"Jex.Resolver.html#resolve/1","title":"Jex.Resolver.resolve/1","type":"function"},{"doc":"Determines what module should be injected into a caller. Recieves the module that was the original target of an alias and should return another module that implements the same interface.","ref":"Jex.Resolver.html#c:resolve/1","title":"Jex.Resolver.resolve/1","type":"callback"}]